﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Problems.BinPacking.Interfaces;
using HeuristicLab.Problems.BinPacking.Shapes;
using HeuristicLab.Data;
using HeuristicLab.Common;
using HeuristicLab.Problems.BinPacking.PackingPlans;
using HeuristicLab.Problems.BinPacking.Dimensions;
using HeuristicLab.Problems.BinPacking.PackingBin;
using HeuristicLab.Problems.BinPacking.PackingItem;

namespace HeuristicLab.Problems.BinPacking.Evaluators {
  [Item("Bin-Utilization Rectangular Identical-Bin Evaluator", "<Description missing> Found in Lee:2010")]
  [StorableClass]
  public class BinUtilizationRectangularIdenticalBinEvaluator : BinUtilizationRegularIdenticalBinEvaluator<TwoDimensionalPacking, RectangularPackingBin, RectangularPackingItem> {

    [StorableConstructor]
    protected BinUtilizationRectangularIdenticalBinEvaluator(bool deserializing) : base(deserializing) { }
    protected BinUtilizationRectangularIdenticalBinEvaluator(BinUtilizationRectangularIdenticalBinEvaluator original, Cloner cloner)
      : base(original, cloner) {
    }
    public BinUtilizationRectangularIdenticalBinEvaluator() : base() { }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new BinUtilizationRectangularIdenticalBinEvaluator(this, cloner);
    }
  }
}
